10   REM --------------------------------------------------------------------
20   REM Biorhythmus (c) by Frank Kaefer 1987-1994 V3.0
30   REM History:
40   REM          V1.0 ZX-80 Basic (ZX-80 with 16 kB RAM)
50   REM          V2.0 TRS-80 Basic (Video Genie)
60   REM          V2.1 C-64 Basic
70   REM          V2.2 OS-9 Basic (OS-9/68000 on Atari ST)
80   REM          V3.0 GW-Basic
90   REM --------------------------------------------------------------------
100  PI=3.14159265
110  REM --------------------------------------------------------------------
120  REM Daten aus den Datazeilen lesen
130  REM --------------------------------------------------------------------
140  DIM WOCHENTAG$(7)
150  DIM MONATSTAG(12)
160  DATA "Sunday","Monday","Tuesday","Wednesday","Thursday"
170  DATA "Friday","Saturday"
180  DATA 31,28,31,30,31,30,31,31,30,31,30,31
190  FOR I=1 TO 7
200  READ WOCHENTAG$(I)
210  NEXT I
220  FOR I=1 TO 12
230  READ MONATSTAG(I)
240  NEXT I
250  REM --------------------------------------------------------------------
260  REM Start
270  REM --------------------------------------------------------------------
280  PRINT
290  PRINT "Biorhythm (c) 1987-1994 V3.0"
300  REM --------------------------------------------------------------------
310  REM Eingabe des heutigen Datums
320  REM --------------------------------------------------------------------
330  PRINT
340  PRINT "Date     [<RETURN> for Systemdate] (DD.MM.YYYY) : ";
350  INPUT DTMP$
360  IF LEN(DTMP$) <> 10 THEN DTMP$=MID$(DATE$,4,2)+"."+MID$(DATE$,1,2)+"."+MID$(DATE$,7,4)
370  T=VAL(LEFT$(DTMP$,2))
380  M=VAL(MID$(DTMP$,4,2))
390  J=VAL(RIGHT$(DTMP$,4))
400  TH=T
410  MH=M
420  JH=J
430  REM --------------------------------------------------------------------
440  REM Eingabe des Geburtstages
450  REM --------------------------------------------------------------------
460  PRINT "Birthday [<RETURN> for 04.12.1965] (DD.MM.YYYY) : ";
470  INPUT DTMP$
480  IF LEN(DTMP$) <> 10 THEN DTMP$="04.12.1965"
490  T=VAL(LEFT$(DTMP$,2))
500  M=VAL(MID$(DTMP$,4,2))
510  J=VAL(RIGHT$(DTMP$,4))
520  TG=T
530  MG=M
540  JG=J
550  GOSUB 1170
560  TA=TA-INT(TA/7)*7
570  GTAG=TA+1
580  REM --------------------------------------------------------------------
590  REM Abfrage, ob und wo Kurve oder Tageswerte ausgegeben werden sollen
600  REM --------------------------------------------------------------------
610  REM GOTO-START
620  PRINT
630  DRUCKER$="false"
640  PRINT "Output to screen or printer [<RETURN> for Screen] (s/p) ";
650  INPUT AUSGABE$
660  IF AUSGABE$="s" THEN DRUCKER$="false"
670  IF AUSGABE$="p" THEN DRUCKER$="true"
680  PRINT "Values for today or Graph   [<RETURN> for Graph]  (v/g) ";
690  INPUT AUSGABEART$
700  IF AUSGABEART$="v" THEN GOTO 720
710  GOTO 1320
720  REM GOTO-START
730  REM --------------------------------------------------------------------
740  REM Berechnung der vergangenen Tage
750  REM --------------------------------------------------------------------
760  J=JG
770  M=MG
780  T=TG
790  GOSUB 1170
800  TAG=TA
810  J=JH
820  M=MH
830  T=TH
840  GOSUB 1170
850  TAH=TA
860  TAGE=TAH-TAG
870  GOSUB 2110
880  IF DRUCKER$="false" THEN PRINT
890  IF DRUCKER$="false" THEN PRINT "The birthday "; TG"."MG"."JG; " is a "; WOCHENTAG$(GTAG)
900  IF DRUCKER$="false" THEN PRINT "Age in days: "; TAGE
910  IF DRUCKER$="true" THEN LPRINT
920  IF DRUCKER$="true" THEN LPRINT "The birthday "; TG"."MG"."JG; " is a "; WOCHENTAG$(GTAG)
930  IF DRUCKER$="true" THEN LPRINT "Age in days: "; TAGE
940  REM --------------------------------------------------------------------
950  REM Berechnung der drei Werte fuer das angegebene Datum
960  REM --------------------------------------------------------------------
970  PHYS=INT(50*(1+SIN((TAGE/23-INT(TAGE/23))*360*PI/180)))
980  EMOT=INT(50*(1+SIN((TAGE/28-INT(TAGE/28))*360*PI/180)))
990  GEIST=INT(50*(1+SIN((TAGE/33-INT(TAGE/33))*360*PI/180)))
1000 REM --------------------------------------------------------------------
1010 REM Ausgabe der Werte
1020 REM --------------------------------------------------------------------
1030 IF DRUCKER$="false" THEN PRINT "Biorhythm    "; TH"."MH"."JH
1040 IF DRUCKER$="false" THEN PRINT "Physical:    "; PHYS; "%"
1050 IF DRUCKER$="false" THEN PRINT "Emotional:   "; EMOT; "%"
1060 IF DRUCKER$="false" THEN PRINT "Mental:      "; GEIST; "%"
1070 IF DRUCKER$="false" THEN PRINT
1080 IF DRUCKER$="true" THEN LPRINT "Biorhythm    "; TH"."MH"."JH
1090 IF DRUCKER$="true" THEN LPRINT "Physical:    "; PHYS; "%"
1100 IF DRUCKER$="true" THEN LPRINT "Emotional:   "; EMOT; "%"
1110 IF DRUCKER$="true" THEN LPRINT "Mental:      "; GEIST; "%"
1120 IF DRUCKER$="true" THEN LPRINT
1130 END
1140 REM --------------------------------------------------------------------
1150 REM Unterprogramm zur Berechnung der vergangenen Tage
1160 REM --------------------------------------------------------------------
1170 REM GOSUB-START
1180 TA=0
1190 IF M<=2 THEN TA=(M-1)*31 : GOTO 1240
1200 IF J/4=INT(J/4) THEN TA=1
1210 IF J/100=INT(J/100) THEN TA=0
1220 IF J/400=INT(J/400) THEN TA=1
1230 TA=TA+INT((306*M-324)/10)
1240 REM GOTO-START
1250 TA=TA+(J-1)*365+INT((J-1)/4)
1260 TA=TA-INT((J-1)/100)+INT((J-1)/400)
1270 TA=TA+T
1280 RETURN
1290 REM --------------------------------------------------------------------
1300 REM Ausgabe einer Kurve
1310 REM --------------------------------------------------------------------
1320 REM GOTO-START
1330 PRINT
1340 PRINT "Graph for how many days : ";
1350 INPUT KTAGE
1360 KTAGE=KTAGE-1
1370 DIM GRAPH$(51)
1380 REM --------------------------------------------------------------------
1390 REM Berechnung der vergangenen Tage
1400 REM --------------------------------------------------------------------
1410 J=JG
1420 M=MG
1430 T=TG
1440 GOSUB 1170
1450 TAG=TA
1460 J=JH
1470 M=MH
1480 T=TH
1490 GOSUB 1170
1500 TAH=TA
1510 TAGE=TAH-TAG
1520 GOSUB 2110
1530 IF DRUCKER$="false" THEN PRINT
1540 IF DRUCKER$="false" THEN PRINT "The birthday "; TG"."MG"."JG; " is a "; WOCHENTAG$(GTAG)
1550 IF DRUCKER$="false" THEN PRINT "Age in days: "; TAGE
1560 IF DRUCKER$="false" THEN PRINT
1570 IF DRUCKER$="false" THEN PRINT TAB(15); "P=Physical, E=Emotional, M=Mental"
1580 IF DRUCKER$="false" THEN PRINT
1590 IF DRUCKER$="false" THEN PRINT TAB(15); "bad condition"; TAB(52); "good condition"
1600 IF DRUCKER$="true" THEN LPRINT
1610 IF DRUCKER$="true" THEN LPRINT "The birthday "; TG"."MG"."JG; " is a "; WOCHENTAG$(GTAG)
1620 IF DRUCKER$="true" THEN LPRINT "Age in days: "; TAGE
1630 IF DRUCKER$="true" THEN LPRINT
1640 IF DRUCKER$="true" THEN LPRINT TAB(15); "P=Physical, E=Emotional, M=Mental"
1650 IF DRUCKER$="true" THEN LPRINT
1660 IF DRUCKER$="true" THEN LPRINT TAB(15); "bad condition"; TAB(52); "good condition"
1670 REM --------------------------------------------------------------------
1680 REM Schleife fuer die Ausgabe der Kurve
1690 REM --------------------------------------------------------------------
1700 FOR Z=TAGE TO TAGE+KTAGE
1710 PHYS=INT(50*(1+SIN((Z/23-INT(Z/23))*360*PI/180)))
1720 EMOT=INT(50*(1+SIN((Z/28-INT(Z/28))*360*PI/180)))
1730 GEIST=INT(50*(1+SIN((Z/33-INT(Z/33))*360*PI/180)))
1740 REM --------------------------------------------------------------------
1750 REM Ausgabe der Werte als Kurve
1760 REM --------------------------------------------------------------------
1770 IF DRUCKER$="false" THEN PRINT TH; MH; JH;
1780 IF DRUCKER$="false" THEN PRINT TAB(15);
1790 IF DRUCKER$="true" THEN LPRINT TH; MH; JH;
1800 IF DRUCKER$="true" THEN LPRINT TAB(15);
1810 PHYS=INT(INT(PHYS)/2+.5)
1820 EMOT=INT(INT(EMOT)/2+.5)
1830 GEIST=INT(INT(GEIST)/2+.5)
1840 P=PHYS+1
1850 E=EMOT+1
1860 G=GEIST+1
1870 REM --------------------------------------------------------------------
1880 FOR CL=1 TO 51
1890 GRAPH$(CL)="."
1900 NEXT CL
1910 GRAPH$(P)="P"
1920 GRAPH$(E)="E"
1930 GRAPH$(G)="M"
1940 GRAPH$(25)="|"
1950 FOR PL=1 TO 51
1960 IF DRUCKER$="false" THEN PRINT GRAPH$(PL);
1970 IF DRUCKER$="true" THEN LPRINT GRAPH$(PL);
1980 NEXT PL
1990 IF DRUCKER$="false" THEN PRINT
2000 IF DRUCKER$="true" THEN LPRINT
2010 REM --------------------------------------------------------------------
2020 TH=TH+1
2030 IF TH>MONATSTAG(MH) THEN MH=MH+1 : TH=1
2040 IF MH>12 THEN JH=JH+1 : MH=1
2050 NEXT Z
2060 IF DRUCKER$="false" THEN PRINT
2070 END
2080 REM --------------------------------------------------------------------
2090 REM Kopf BIORHYTHMUS
2100 REM --------------------------------------------------------------------
2110 REM GOSUB-START
2120 IF DRUCKER$="false" THEN PRINT
2130 IF DRUCKER$="false" THEN PRINT TAB(32);"BIORHYTHM"
2140 IF DRUCKER$="false" THEN PRINT TAB(32);"========="
2150 IF DRUCKER$="false" THEN PRINT
2160 IF DRUCKER$="false" THEN PRINT TAB(23);"(c) 1987-1994 by Frank Kaefer"
2170 IF DRUCKER$="true" THEN LPRINT
2180 IF DRUCKER$="true" THEN LPRINT TAB(32);"BIORHYTHM"
2190 IF DRUCKER$="true" THEN LPRINT TAB(32);"========="
2200 IF DRUCKER$="true" THEN LPRINT
2210 IF DRUCKER$="true" THEN LPRINT TAB(23);"(c) 1987-1994 by Frank Kaefer"
2220 RETURN
2230 REM --------------------------------------------------------------------
2240 REM End of Program
2250 REM --------------------------------------------------------------------
